// doc no lari sayi
// 11-prec recall

// PR lar outputa diil in memory array e yaziliyo, burada interpolate edilebilir

// jan 21 11 point results icin output file yazilacak


// jan 17
// ya su an gene her clusterdan ds tane seciyoz, yanliz oradaki looptan
// exit etmek lazim her 2 CBR versionunda da yoksa, ayni doc 1den fazla
// eklenip precision'i falan sisirir => Solution: break ettim!

// Onemli not: bu versionda her clusterdan ds tane secmek cok zor vev COSTLY, ayric biz
// zaten tum clusterlara bakiyoz, bu bakimdan ben overall top best-clus*best_docs secicem
// consistent olmak icin digrer codelari fs bve cbr-old degistirmek gerekebilir...
// ama bu ds icin ciddi bi justification yoksa oyle yapalim bence!!!



//cbr-new4.c: old4.c ustune gelistirildi, skiped version


// buglari duzelt, adam gibi bi ornek set icin tamamen run, control et olayi
// sonra cok az bi kod degistirip oburunu yaz
// tum kontrolleri yapip time alalim
// niye bu salak log file'a bi si yazmiyo ya? uyuz mu ne? ok!

// cbr4: definelarda exact sayi vermeyi unutma
// evde process_query ve eval_query de docvec size buyuk olunca goctu, onun
// icin ayrica qsize define ettim

// problems;
// 1) define exact olayi
// 2) BUG indexer 5 da toWrite[16 ] yap,
//     fs2 de falan <=Docsize olmali looplar doc 1den basladigi icin, gerekirse duzelt
//     ya da defineda docnum+1 yap -> 2. tercih edilecek
// 3) centroid indexi kactan basliyo bi bak
// 4) Ic file format...enginle konus. OK
// 5) asagidaki maddeler
// 6) gerekirse burada centroid weight falan hesaplanabilir ama zor olur biraz

// cbr3: intention is to handle IC matching and below problems...

// tomorrow: 1) inverted IC yi okuyup, best clusterlari bul OK
// 2) eval func hep top n e gore, ama biz de resultlar degisirse, n tane bulamazsa
// ne olur? FSde bunu nasilk yapmisim ya?Sanirim 0 lari koymusum.
// bu durumda belki burda da aynini yapmali? ya da fs2 de de her query icin actual
// result size kullanmam lazim yaa!!!! offfffffffffff!!1
// 3) su looptan exit isini unutma!!!
// 4) check global sorting, dogru anladim di mi? OK
// 5) skipped de sadece acc array update merge-sorta benzeyecek, sonrasi fs2den
//    basi ise burdan yani IC bulma; yani 3-5 satir bi si implement etmek yetecek!
// yalniz acc array de fazladan cluster fieldi tutmak gerekecek!

// cbr2: final result globally sorted diye assume ediyorum!
// onemli: overlapda loopdan exit olayi???


//***** doc num 1 fazla olsun 1 den basladigi in unutma!!!,

// cbr-old1: 12jan2002
// bu kod paperdaki org. CBR yapacak
// mantk su: her query icin IIS den acc array create et
// bundan sonra (veya once-no matter) best matchi ng clusterlari bul
// acc arrayi traverse, her cluster icin ds tane buluncaya kadar, veya
// acc bitinceye kadar devam et
// bulunan top resultlar olacak - bunlari yeniden kendi icinde sort ETMIYORUM!


// fs2: okulda:
// 1) mean avg prec implement edildi
// 2) ranked_eval.text de bazi print satirlari kaldirildi
// 3) TOPN 10 yapildi prec artti, recal dustu, ama mean avg hala %17 ya


// FS1; system for rankin querying
// pek cok sabit var, definelara dikkat et
// bazen gocuyo, tahminim blank line handle ederken olabilir...check et
// CEVAP: err_out ' a yazmaya calisiyomus, fs1 de duzeltildi, okulda.
// su an title+ desc + narr hanle ediyo
// TBD:
// 1) su short - long icin handling i ekle: hangi tagleri process edelim
// 2) bsearch not found bi saydir. kac case
// 3) boolean impement et!


// indexer5.c: read wordlist with CFC values
// compute tf*CFC for doc terms, normalize them and THEN add to index
// to do this, change index entries to be double, and add index function, too
// wordlist, entry ve dvector structurelara weight fieldi eklndi
// CFC weight wordlistten okuyup, term weighti tf*cfc oarak buluyo, dvece kaydediyo
// sonra dvec normalize edilip her bir term icin doc_id+weight_in_doc
// inveted indexe yaziliyo... Print alinan yerlerde falan da duzeltme oldu tabii
// CFC degisirse burada bi sey yapma. Tf veya nc degisirse bu kodda duzeltme gerekir
// unutma,son dvec outputa looptan sonra yazildigi icn 2 yerde duzeltme gerekiyo...

// indexer 3;
// read Wordlist file, read document vector, create the inverted index and
// write to a binarty file. Inverted entry lengths are known apriori.
// In this version, I'll use direct file access, mnext I'll use mem_map
// ONEMLI: Tum islemlerde index 1 den basliyo!!!!!!!!

// simdi mem_map yapabiliriz...
// large scalede bi deneyelim, unutma array length degisebilir
// tum document mem de tutuluyo degisik weighting kullanirsak diye...

//sigir49:
// 1) stems
// 2) sorts the wlist and makes two passes
// 3) for padding, we use -1
// 4) so doc no and term no starts from 1, does decrement by 1 while processing
// 5) if an indexed word could not found in the index due to stemming algorithm
// inconsitency, we do not exit, just print an error message...
// 6) ekrana kac word oldugu listte dogru olarak basiliyor...
// 7) Tum mesajlar bi error file a da yazdirilacak.. (buraya kadar sigir45 de ok)
// 8) In 47, I will use bseacrh and clean the code...So 46 is same as 45, as a backup
// In 47,some old code deleted, old arrays will be cleaned up to save mem
// And finally try to use bsearch in the second pass
// bsearch is ok, but be careful: WordList index is found using POINTER ARITHMETICS
// IN 48, word structure size azaltilacak...ok!
// IN 49, also return the max_rank, we may use in inverted list part!
// In 50, write wordlist simpler
// In 51, try to use the trie..

// sigir2.c: 1)long intler problem olabilir
// 2)second pass gerekirse sadece process relation icinde bir if le halledilir
// 3)birden fazla file isi...
// 4)doc size 10000, wordlist 100000, linesize 1000 unutma...
// 5)her seyi sanki R rel process edilir gibi, processingR=1 yaparak yapiyoz


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
//#include <time.h> // sys vb. okul icin... see rfp
#include "ulib.h"

//#include <stem1.h>
//#include "f:\ir\project\inverted\btrie.h"
//#include "btrie.h"

#include "sglobal.h"




typedef struct vec {
       int index;
       double weight;
       } *VP, VectorComp;


typedef struct vec2 {
      VectorComp VecElement[1];
      int nonzero_elements;
      } Vector;



typedef struct doc_ve {
        long int index;
        char word[70];
        long int rank_in_doc;
        double term_weight; //INDEXER5
        long int address; // address of where to start reading;
        } DocVec, *DV;


typedef struct rec {
        char TName [1];
        char Cont_field [1];
        //char TDom [100];
        //char TSource [10];
        char tokens [1][3]; // to keep tokens in memory after tokenizing
        int token_no;
        char dc_token[1];

        double importance; // topic, source importance value
        double propogate_val; // here max. sim * importance but in general
        Vector *v;
        } *TP, Tuple;

typedef struct inv_ent {
        int doc_id;
        //int freq_in_doc;
        double weight;
        } InvEntry;

// In this version, I keep only the necessary structures for each word:
// namely; a_Word, occurrs_in_docs, CFCweight and disk_address

typedef struct words {
        char a_word[TOKEN_SIZE]; // for handling queries
        int occurs_in_docs; // to retrieve inv entires and also weight queries
        long int disk_address; // address to access in binary file
        double CFCweight; // CFC weight of the word

        // jan 15, I add a pointer to an array of inverted entries to keep the centroid IC
        // here we lose memory, ie. 8 bytes*n.
        // we could map ic terms to numbers and keep a specific structure as well
        // but it could require table look-up, i.e. log n bsearch, ;I don't want
        InvEntry * clusterList;

        int cent_list_length;
        long int IC_disk_address;

        } *WP, Word;

struct timeval *start_t, *end_t;
int elapsed_time;
struct timezone *tz;

ptimer process_time; // total time

time_t tstart, tend, tsum = 0;

Tuple rel_R [1]; // in these arrays assume keeping 2000 tuples of each relation
Tuple rel_S [1];

//Result Result_rel [1];

Word WordList[WORD_NO];
InvEntry buffer[BUFFERSIZE];

InvEntry cent_buffer[BUFFERSIZE];

long int max_R, max_S; // no of tuples in R and S

int no_of_matches; // no of joined tuples
int no_of_comparisons; // no of compared tuples

double match_threshold = 0.5;

// these are here because i am so stupid that i could not pass them as arguments
double score;
int found = 0;
int word_no_in_list=0;

char stopwords[NOSTOPWORD][50] ; // to keep stop words

//double Vector1[WORD_NO]; // SIM9: will represent two tuples
//double Vector2[WORD_NO];

Vector *Vector1;
Vector *Vector2;

DocVec DVector[DOC_SIZE]; // to keep all term in a doc with dublications
int d_size=0; // length of current doc

long int doc_no = 0; // total no_of docs in all files


int trie_start = 0;
int err=0;

FILE * ifp, *j_ifp, *eval_out, *ICfile, *ICMfile, *cluster_file;
FILE * out, *d_out, *err_out, *out_2, *entry_out, *entry_ifp, *record_out, *entry_ic;

char tName2[300];

int processing_R = 1;
int processing_S = 0;

char final_tokens [TOKEN_NO][TOKEN_SIZE];

typedef struct res {
        int doc_index;
        double sim_rank;
        int last_updated_by;
        } Result, *RP;


Result accumulator[DOC_NUM]; // accumulator array for partial similarities

Result centroid_accumulator[NC+1]; // acc for centroids to find best clusters

// to keep top results found for each query
Result results [QUERY_NO][BEST_DOCS*BEST_CLUSTERS]; // 12 Jan 2002, modified!
Result temporary [TOP_N];

// to keep relevant results
int relevants[RELEVANT_SIZE];

// 12 jan :to keep results in a temporary manner, then they will be put in the above
// real results array
// Note that either necessary or not, I will implement this in cbr-new to make both
// codes similar in this redundant work

typedef struct result_lists {
        int current;
        //Result *res_array;
        } Res_type; // this would keep the docs for each cluster in an entry

Res_type temp_results[NC];

// the structure will be initialized by reading a file, I hope
typedef struct inverted_cluster_membership {
         int clusters_doc_in;
         int *cluster_list;
         } ICMtype; //for each doc an array that includes the cluster list for this document

ICMtype ICM[DOC_NUM];


int best_clusters[BEST_CLUSTERS];

// 15 jan
InvEntry tempICList[MAX_LIST_LENGTH];

// for purposes of statistics

int total_list_length = 0;
int total_node_access = 0;

int sum_list_length = 0;
int sum_node_access = 0;

typedef struct eval_str
        {
         double prec[TOP_N];
         double recall[TOP_N];
         } EvalStr;

typedef struct inter_eval_str
        {
         double prec[CUT_LEVEL];
         double recall[CUT_LEVEL];
         } InterStr;


EvalStr PR_values[QUERY_NO];

InterStr Interpolated_PR[QUERY_NO];

// remeber to initialize??
// allrel 0 olursa hic loopa girmez eval func da o yuzden bu arrayler initialize edilmeli

typedef struct c_str {
        //int c_id;
        int capacity;
        int size;
        } ClusModel;

ClusModel C3M_Cluster[NC+1];   // here NC actual no of clusters

 int grand_total_docs = 0;

 int max_total = -1;
 int min_total = DOC_NUM+1;

 double t_sum = 0;

int total_qlength = 0; // to find out avg qury length

int max_qlength = -1;
int min_qlength = 999999;

double term_generality = 0;
int max_freq_term = -1;
int min_freq_term = 999999;

///////////////////////////////////////////////////////////////////////////////////////////////////////////

init_PR()
{
 int i, j;

 for (i=0; i<QUERY_NO; i++)
   for (j=0; j<TOP_N; j++)
   {
    PR_values[i].prec[j] = 0;
    PR_values[i].recall[j] = 0;
   }
}


init_Interpolated_PR()
{
 int i, j;

 for (i=0; i<QUERY_NO; i++)
   for (j=0; j<CUT_LEVEL; j++)
   {
    Interpolated_PR [i].prec[j] = 0;
    Interpolated_PR [i].recall[j] = 0;
   }
}



interpolate_PR()
{

   int i, j, k;
   double recall_level = 0.0;
   int start_index = 0;
   double max_prec= 0.0;
   int cut_no = 0;

   for (i=0; i<QUERY_NO; i++)
   {
        recall_level = 0.0;
        start_index = 0;
        max_prec = 0;
        cut_no = 0;


        while (recall_level <= 1.0) //&& start_index <TOP_N)
        {
          max_prec = 0.0;
          // onemli bu olmali

          while(PR_values[i].recall[start_index] < recall_level && start_index<TOP_N)
             start_index++;

          // eger esitsem o indexden basla, dillse looptan buyuk olarak cikti
          // 1 azalt!
          if (PR_values[i].recall[start_index] > recall_level && start_index >0 && start_index<TOP_N)
             start_index--;


          // find max from start index to top level
          for (k=start_index; k<TOP_N; k++)
              if (PR_values[i].prec[k] > max_prec)
                  max_prec = PR_values[i].prec[k];

             // if (i==2)
          //printf("max %lf\n", max_prec);


          Interpolated_PR[i].prec[cut_no] = max_prec;
          Interpolated_PR[i].recall[cut_no] = recall_level;
          //if (i==2)
            // printf("al %lf\n", Interpolated_PR[i].prec[cut_no]) ;


          recall_level += 0.1;
          cut_no ++;


        } //outer while

        // ciktiginda mesela baz leveller set edilmemisse onlar initializedan
        // 0 olacak

      } // end outer for
      //printf("ahhhhhhhaaaaa %lf\n",Interpolated_PR[2].prec[1]);

}

print_Interpolated_PR()
{

   int i, j;
   double sum;

   fprintf(eval_out, "\n");
   fprintf(eval_out, "11 POINT PR VALUES for all queries\n");
   fprintf(eval_out, "          ");
   for (j=0; j<CUT_LEVEL; j++)
        fprintf(eval_out,"%d        ", j+1);
   fprintf(eval_out, "\n");

           //printf("ahhhhhhhaaaaa %lf\n",Interpolated_PR[2].prec[1]);

   for (i=0; i<QUERY_NO; i++)
   {
       fprintf(eval_out,"q_no: %d",i);
       for (j=0; j<CUT_LEVEL; j++)
       {
        fprintf(eval_out," %lf", Interpolated_PR[i].prec[j]);
        //if (i==2)
        //printf("%lf\n",Interpolated_PR[i].prec[j]);
        fflush(out);
       }
       fprintf(eval_out, "\n");
   }

   fprintf(eval_out, "Av prec");
   for(j=0; j<CUT_LEVEL; j++)
   {
     sum = 0;
     for (i=0; i<QUERY_NO; i++)
         sum += Interpolated_PR[i].prec[j];

     fprintf(eval_out," %lf", sum/QUERY_NO);
   }

   fprintf(eval_out, "\n");



}

/////////////////////////////////////////////////////////////////////////////

void create_C3M_Cluster(char *rel_name)
{
   char line[MAX_TUPLE_LENGTH];

   int i, c_id, capacity, seed;

   int sum;
   //open file
   if (!(cluster_file = fopen(rel_name,"rt")))
   {
      printf("file not found!\n");
      exit(1);
   }

   fgets(line, MAX_TUPLE_LENGTH, cluster_file); // read <doc> line
   line[strlen(line)-1]=NULL;

   if (line[0]!='#')
   {
      printf("File format error\n");
      exit(1);
   }

   // Assuming file format is correct
   for (i=0; i<NC; i++)
   {
      fscanf(cluster_file, "%d %d %d\n",&c_id, &capacity, &seed);

      // process data, as clusters start from 1
      C3M_Cluster[i+1].capacity = capacity + 1; // the one is for the seed
      C3M_Cluster[i+1].size = 0;

      fprintf(out, "cluster %d, capacity %d\n", i+1, C3M_Cluster[i+1].capacity);


      line[0] = NULL;

      while (!feof(cluster_file)  && line[0]!='#')
      {
       fgets(line, MAX_TUPLE_LENGTH, cluster_file); // read #
       line[strlen(line)-1]=NULL;
      }
   }

   fclose(cluster_file);

   sum = 0;
   for (i=0; i<NC; i++)
    sum += C3M_Cluster[i+1].capacity;

   printf("no of documnets clusterd by C3M is %d\n", sum);
}

/////////////////////////////////////////////////////////////////////////////

int ord_ordering (int * p, int * q)
{
  if (*p > *q)
     return 1;
  if (*p < *q)
     return -1;
  return 0;
}



int separator(char ch)
{
  /*if (ch == ' ' || ch == ',' || ch == '\t')*/
  if (!isalnum(ch))
    return(1);
  else
    return(0);
}




// SIM11; changed strcmp !!! 30.04.2001
int FindStopIndex(int start,int end,char word[50])
{
  int length;
  int index;

  length=end-start+1;
  index=start+(length/2);

  if (length<=0)
    return (-1);
  else if (strcmp(word,stopwords[index])<0)
    return(FindStopIndex(start,index-1,word));
  else if (strcmp(word,stopwords[index])>0)
    return(FindStopIndex(index+1,end,word));
  else
    return(index);

}


// VECTOR functions

// compute vector length
double v_length(Vector *Vect)
{
 int i;
 double sum;

 sum = 0;

 for (i=0; i<Vect->nonzero_elements; i++)
     sum += Vect->VecElement[i].weight * Vect->VecElement[i].weight;

 return (sqrt(sum));
}


void v_normalize(Vector *v)
{
    int i;
    double length;

    length = v_length(v);


    for (i=0; i<v->nonzero_elements; i++)
         v->VecElement[i].weight = v->VecElement[i].weight/length;

}

/*
void v_normalize(double *Vector)
{
  int i;
  double length;

  length = v_length(Vector);


  for (i=0; i<WORD_NO; i++)
     Vector[i] = Vector[i] /length;

}
*/

double v_dotProduct(Vector *v1, Vector *v2)
{
  int i,k;
  double sum;
  sum = 0;

  // IMPORTANT: assuming each index appears only once in a vector

  for (i=0; i<v1->nonzero_elements; i++)
     for (k=0; k<v2->nonzero_elements; k++)
        if (v1->VecElement[i].index == v2->VecElement[k].index)
            {
            sum += v1->VecElement[i].weight * v2->VecElement[k].weight;
            //break; // by assumption, no index (word) is duplicate in a vector
            };



  //sum += v1[i]*v2[i];

  //printf("dot pro is %lf at comp %d\n",sum, no_of_comparisons);
  return (sum);


}

// compute the cosine of angle between two vectors
double v_VecCos( Vector *v1, Vector *v2)
{
  double t= v_dotProduct(v1, v2); // as i normalize, no need any more /(v_length(v1)*v_length(v2));
  fprintf(out, "dot %lf length %lf cos is %lf\n",v_dotProduct(v1, v2),v_length(v1)*v_length(v2), t);
  //fprintf(out,"cos is %lf\n", t);
  return t;

}

// linear search in the word list
// returns the index if the key is found
// and returns where to add if not found
int my_lsearch (char *key, Word *List)
{
  int i;

  i=0;
  printf("eeee \n");

  while (strcmp(List[i].a_word,"")!=0 && i<WORD_NO)
  {
    if (strcmp(List[i].a_word, key)==0)
       {
       found = 1;
       return i;
       }
    i++;
    printf("%d \n", i);
  }
  found = 0;
  return i;
}

int index_order(DV dvec1, DV dvec2)
{
   if (dvec1->index > dvec2->index)
      return 1;
   if (dvec1->index < dvec2->index)
      return -1;
   return 0;
}


int lex_order3(WP w1, WP w2)
{
  return strcmp(w1->a_word, w2->a_word);
}


int lex_order2(TP t1, TP t2)
{
  return strcmp(t1->tokens[0], t2->tokens[0]);
}

int lex_order(char *s1, char *s2)
{
  return strcmp(s1, s2);
}

int lex_order5(TP t1, TP t2)
{
  return strcmp(t1->dc_token, t2->dc_token);
}

// changed to provide decreasing order, compare with order func. below
int prop_order(TP t1, TP t2)
{
  if (t1->propogate_val > t2->propogate_val)
     return -1;
  if (t1->propogate_val < t2-> propogate_val)
     return 1;
  return 0;

}

/* I replaced '\0' with NULL in the below function */

void read_next_value(char *into)
{


  int j;
  int i;
  char tempo[300];

  //printf("tnmae is %s \n", tName2);
  i = 0;
  /* skip separators */
  while (separator(tName2[i]) && tName2[i] != NULL ) i++;

  j=0;
  while (!separator(tName2[i]) && tName2[i] != NULL) {
    into[j++]=tName2[i];
    i++;
  }
  into[j]=NULL; /* into contains a value as a string */

   /*
  j=0;
  while(tName2[i]!=NULL)
  {
     tName2[j]=tName2[i];
     i++;
     j++;
    }
 */

  //printf("tnmae is %s \n", tName2);
  j=0;
  while(tName2[i]!=NULL)
  {
     tempo[j]=tName2[i];
     i++;
     j++;
    }

  tempo[j] = NULL;
  strcpy(tName2, tempo);

  //printf("tnmae and tempo are %s %s \n", tName2, tempo);
} /* read_next_value */

/* this function would process TName field of a given tuple of a relation */
/* processing means tokenzing the words in the TName and locating these in the tokens*/
/* field of the relatipn */

void process_tuple(char *line, long int tuple_no)
{
 char *tName, *rName;
 int trie_key;

 char tokens[TOKEN_NO][TOKEN_SIZE];
 //char final_tokens [30][30];
 char str[300], temp[300], tmp[300];
 int token_found,i,q, tokens_left, index;

 //28 NOV
 WP word, sword;
 int add1, add2, word_size;

  //tName= (char*)malloc(sizeof(char)*30);
  //rName=tName;
  //strcpy(tName, Relation[p].TName);
 strcpy(tName2, line); // DO NOT change tName2, read_next_val ona gore yazilmis!!!
 //printf("look, tuple TName is :%s and length is %d\n", tName2, strlen(tName2)); // debugging


 // tokenize the TName field
 token_found = 0;
 read_next_value(str);


 while  (  *str != NULL)
 {

   strcpy(tokens[token_found],str);
   token_found++;
   read_next_value(str);
 }

 // omit the tokens that are found in the stop list
 tokens_left = 0;
 for (i=0; i<token_found; i++)
 {

    for (q=0; q<strlen(tokens[i]); q++)
         tokens[i][q] = tolower(tokens[i][q]);

    if (FindStopIndex(0,NOSTOPWORD-1,tokens[i]) == -1)
    {

     strcpy(tmp, tokens[i]);

     //NEW
     //if (!sec_pass)
     //{
     // question: does it stem identical in both passes?
     /*
     Stem(tokens[i]);

     if (strlen(tokens[i])==0)
        {
        strcpy(tokens[i], tmp);
        }
     */
     //}

     strcpy(final_tokens[tokens_left], tokens[i]);
     found=0;
        if (processing_R)
        {
         // Here, wordlist is sorted, so I prefer to use a bsearch
          //index=my_lsearch(tokens[i], WordList);
         /*if (index>word_no_in_list+1)
           { printf("nooluyo len\n");
           exit(1);}
           */
         // 28 NOV
         sword = (WP) malloc(sizeof(Word));
         // yeni koydum...
         word = (WP) malloc(sizeof(Word));

         if (sword == NULL)
         {  printf("could not allocate space\n");
            exit(1);
         }

         strcpy(sword->a_word,tokens[i]);
         //printf("%s ariyorum...\n", sword->a_word);
         word = (WP) bsearch(sword->a_word ,WordList, word_no_in_list+1, sizeof(WordList[0]), lex_order);

         if (word)
         {
            found = 1;
            // not sure if this is a good idea
            add1 = (int) WordList;
            //printf("array add. %d ", add1);
            add2 = (int) word;
            //printf("word add. %d ",add2);
            word_size = sizeof(Word);
            //printf("word %d\n", word_size);

            // Note that, the expression gives exactly the array index of WordList, starting from 0 of course
            //printf("al %s index %d rank %d\n",word->a_word,((add2-add1)/word_size), word->rank_R);
            index = (add2-add1)/word_size;

            free(sword);
         }
         else
         {    printf("bsearch could not found\n");
              //fprintf(err_out, "ERROR bsearch could not found\n");

         }

         if (found) // will be surely found!!!
         {

         // now add this term to the current doc vector
         strcpy(DVector[d_size].word, tokens[i]);
         DVector[d_size].index = index;
         //DVector[d_size].address = WordList[index].disk_address;
         d_size++;

            if (d_size>DOC_SIZE)
            {
             printf("Doc size exceeds %d!\n", DOC_SIZE);
             //fprintf(err_out,"ERROR Doc size exceeds %d!\n", DOC_SIZE);
             exit(1);
            }

         } // if_found
         else // not found
         {

          printf("!!!!!!!In the second pass, could not found an index %s in wordlist\n", tokens[i]);
          //fprintf(err_out, "ERROR :In the second pass, could not found an index %s in wordlist\n",sword->a_word);
          //exit(1);
          err++;
         }
        }

     tokens_left++;
    }

 } //end_for



 fprintf(out, "%ld ", tuple_no);
 for (i=0; i<tokens_left; i++)
     {
       //fprintf (out,"token no %d is %s\n",i,final_tokens[i]); // debugging
       fprintf (out,"%s ",final_tokens[i]); // debugging
       fflush(out);

     }
     fprintf(out, "\n");


}

int time_diff(struct timeval *finish, struct timeval *start)
/* time difference in miliseconds */
{
  int time_in_sec, time_in_usec;

  // commented at case!
  //time_in_sec = finish->tv_sec - start->tv_sec;
  //time_in_usec = finish->tv_usec - start->tv_usec;


  return (time_in_sec * 1000) + (time_in_usec / 1000);
} /* time_diff */

/*
int
random_int (int max)
{
  if (max == 0) return (0);
  return (random()%max);
}

*/
void closer(char *open_tag, char *close_tag)
{
   int i;
   close_tag[0] = '<';
   close_tag[1] = '/';

   i=1;
   while (open_tag[i] != NULL)
   {
      close_tag[i+1] = open_tag[i];
      i++;
   }

   close_tag[i+1] = NULL;

}

void extract_header(char *header, char *line)
{

  int i;

  //printf("input: %s\n", line);

  i=0;

  if (line[i]!= '<')
  {
      header[i] = NULL;
      return;
  }
  else
  {
      //printf("here\n");
      //printf("char0 is %c\n",line[5]);
      while (line[i] != ' ' && line[i] != '>')
      {
         //printf("char is %c\n",line[i]);
         header[i] = line[i];
         i++;
         //printf("loop\n");
      }
  }

  header[i] ='>';
  i++;
  header[i] = NULL;
  return;

} /* extract_header */

void extract_content(char *line, char *content)
{
   // do real extraction
   char tmp[MAX_TUPLE_LENGTH];
   int i, j;
   int opened; // to denote if a tag is open or not

   opened = 0;
   j=0;

   for (i=0; i<strlen(line); i++)
   {
     if (line[i] == '<')
        opened = 1;
     else if (line[i] == '>')
        opened = 0;
     else if (!opened)
     {
        tmp[j] = line[i];
        j++;
     }
   }
   tmp [j] = NULL;

   strcpy(content, tmp);
}

// initializes the doc vector for the *current* doc
void initialize_doc_vec(int d_size)
{
 int i;

 // just to be safe, I made <=
 for (i=0; i<=d_size; i++)
 {
   strcpy(DVector[i].word,"");
   DVector[i].index = -1;
   DVector[i].rank_in_doc = -1;
   DVector[i].address = -1;
 }

}


// compute vector length
double dvec_length(int size)
{
 int i;
 double sum;

 //notice DVector is global
 sum = 0;

 for (i=0; i<size; i++)
     sum += DVector[i].term_weight * DVector[i].term_weight;

 return (sqrt(sum));
}


void dvec_normalize (int size)
{
    int i;
    double length;

    length = dvec_length(size);


    for (i=0; i<size; i++)
         DVector[i].term_weight = DVector[i].term_weight/length;

}

void initialize_accumulator()
{
 int i;

 for (i=0; i<DOC_NUM; i++)
 {
      accumulator[i].doc_index = i; // index is itself
      accumulator[i].sim_rank = 0;
      accumulator[i].last_updated_by = -1;
 }

}

 // sorts in decreasing order
int ordering (RP p, RP q)
{
  if (p->sim_rank > q->sim_rank)
     return -1;
  if (p->sim_rank < q->sim_rank)
     return 1;
  return 0;
}


void initialize_temp_results()
{
   int i;

   for (i=0; i<NC; i++)
      temp_results[i].current = 0;
}

int nor_ordering (RP p, RP q)
{
  if (p->doc_index > q->doc_index)
     return 1;
  if (p->doc_index < q->doc_index)
     return -1;
  return 0;
}


// jan 16
// In this skipped version, we do not select best ds docs from best clusters
// but we choose best docs globally over all best clusters, i feel this is
// better and less costly!

// Indeed, I decided to implement both versions, in second version I select
// ds from ns so I again need the CM info, so only improvement of our work will
// be in terms of posting list processing!!! Ve hic diilse list processing
// disinda everything is same to compare!

// So, for very long lists, we may expect an improvement
// + in case of compression, it could be more effective!!!

void run_ranking_query(DocVec *q_vec, int q_size, int q_no)
{
 int i, j, k, b, z, h ;
 long int address;
 int *value;
 int c_key;

 int current_list_node;
 int current_best; // points to the best cluster in best_clusters array
 int block_end;

 int total_docs;


 int counter;
 int no_of_res_found = 0;

 total_list_length = 0;
 total_node_access = 0;

 total_qlength += q_size;

 if (q_size > max_qlength)
    max_qlength = q_size;

 if (q_size < min_qlength)
    min_qlength = q_size;


 // for the query find best matching clusters
 // use IC, create a sorted kucukten buyuge array of best matching clusters

 // initialize_bestmatching vector and centroid accumulator
 for (i=0; i<BEST_CLUSTERS; i++)
     best_clusters[i] = -1; // i don't know start index of clusters 0 or 1

 for (i=0; i<NC+1; i++)
 {
      centroid_accumulator[i].doc_index = i; // index is itself
      centroid_accumulator[i].sim_rank = 0;
 }


 for (i=0; i<q_size; i++)
 {
   if (WordList[q_vec[i].index].cent_list_length > 0)
   {

   //WordList[q_vec[i].index].clusterList = (InvEntry *) malloc(sizeof(InvEntry) * WordList[q_vec[i].index].cent_list_length);

   address = WordList[q_vec[i].index].IC_disk_address;
   fseek(entry_ic, address, 0);
   //fread(WordList[q_vec[i].index].clusterList, sizeof(InvEntry),WordList[q_vec[i].index].cent_list_length, entry_ic);
   fread(cent_buffer, sizeof(InvEntry),WordList[q_vec[i].index].cent_list_length, entry_ic);
   //printf("%d %lf\n", cent_buffer[0].doc_id, cent_buffer[0].weight);

   for (j=0; j<WordList[q_vec[i].index].cent_list_length; j++)
        {

         //fprintf(out, "BAK for term %s: doc id %d weight_in_doc %lf\n",WordList[q_vec[i].index].a_word, buffer[j].doc_id,buffer[j].weight);
         // add accumulator doc_weight * q_term weight
         centroid_accumulator[cent_buffer[j].doc_id].sim_rank += (cent_buffer[j].weight * q_vec[i].term_weight);
         }

    } // if

   }// outer_for


  qsort(centroid_accumulator, NC+1, sizeof(centroid_accumulator[0]),ordering);

  for (i=0; i<BEST_CLUSTERS; i++)
  {
      best_clusters[i] = centroid_accumulator[i].doc_index;
      //fprintf(out, "best cluster %d is %d\n", i, best_clusters[i]);
  }

 // the below part is modified for skipped version

 // clean accumulator array for each query
 initialize_accumulator();

 qsort(best_clusters, BEST_CLUSTERS, sizeof(int),nor_ordering);

 // return the total number of docs considered for this query
 total_docs = 0;

 for (z=0; z<BEST_CLUSTERS; z++)
    total_docs += C3M_Cluster[best_clusters[z]+1].capacity;

 grand_total_docs += total_docs;

 if (total_docs > max_total)
    max_total = total_docs;

 if (total_docs < min_total)
    min_total = total_docs;

// fprintf(out, "Total no of docs in the best clusters for query %d:%d\n",q_no, total_docs);

// printf("Total no of docs in the best clusters for query %d:%d\n",q_no, total_docs);


/////EXTRA!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!/////////////////////////////////

 fprintf(out, "Processing Q %d\n", q_no);

 for (i=0; i<q_size; i++)
 {
   address = WordList[q_vec[i].index].disk_address;
   fseek(entry_ifp, address, 0);
   fread(buffer, sizeof(InvEntry), WordList[q_vec[i].index].occurs_in_docs, entry_ifp);


   total_list_length += WordList[q_vec[i].index].occurs_in_docs;

   current_list_node = 0; // the cluster of first block of docs
   current_best = 0;

   // ya iyi de overlapping iseher cluster icin bir docun weighti tekrar
   // tekrar artacak?
   // naapcaz bunu? uff, her query term icin sadece bi kez update etcez!
   // this is the solution!!!

   while (current_list_node !=-1 && current_best<BEST_CLUSTERS)
   {
      if ( buffer[current_list_node].doc_id < best_clusters[current_best])
        {
        current_list_node = (int) buffer[current_list_node].weight;
        total_node_access++; // count cluster node accesses
        }
      else
      if ( buffer[current_list_node].doc_id > best_clusters[current_best])
         current_best++;
      else // equal, process list and increment both pointers
      {
         total_node_access++;
         if (buffer[current_list_node].weight != -1)
            block_end = (int) buffer[current_list_node].weight;
         else
            block_end = WordList[q_vec[i].index].occurs_in_docs;

         for (j=current_list_node+1; j<block_end; j++)
         {
         //fprintf(out, "BAK for term %s: doc id %d weight_in_doc %lf\n",WordList[q_vec[i].index].a_word, buffer[j].doc_id,buffer[j].weight);
         // add accumulator doc_weight * q_term weight
         // for overlaping docs, we update only once for each term
         if (accumulator[buffer[j].doc_id].last_updated_by <i)
            {
             accumulator[buffer[j].doc_id].sim_rank += (buffer[j].weight * q_vec[i].term_weight);
             accumulator[buffer[j].doc_id].last_updated_by = i; // updated by query i
            }
         // in any case, I access to accumulator for these docs,so;
         total_node_access++;

         }

         // increment both pointers
         current_list_node = buffer[current_list_node].weight;
         current_best++;
      } //else
   }// while_ends

  }// outer_for

  // theh below work can be done more efficiently using heaps etc.
  // sort accum in decreasing order,choose top n, put in result vector
  // OLMAD, doc id yi kaybederim boyle olursa...-> indexi de tuttum, ok now...
  qsort(accumulator, DOC_NUM, sizeof(accumulator[0]),ordering);

// AC
//    for (i=0; i<10; i++)
//      fprintf(out, "top acc result %d is document %d with sim %lf\n", i, accumulator[i].doc_index, accumulator[i].sim_rank);




  // may be optimized easily
  initialize_temp_results();

  // In the below, I use Cluster mmebership info and select ds from each ns
  // instead, I could also select overall top n docs!!!
  // bu asagidaki olay bu versionda biraz olayin mantigini yipratiyor ama neyse!

  //now, from the above I know best clusters and I have the sorted accumulator
  j = 0;    //unutma doc size 1den basliyo, docnum 1 fazla olacak!

//  while (j<DOC_NUM && no_of_res_found<BEST_DOCS * BEST_CLUSTERS)

  while (j<DOC_NUM && no_of_res_found<BEST_DOCS)
  {
   // check for each cluster this documents is in, if it is a best cluster
   for (k=0; k<ICM[accumulator[j].doc_index].clusters_doc_in; k++)
   {
       c_key =  ICM[accumulator[j].doc_index].cluster_list[k];

       //value = malloc(sizeof(int));
       value = (int *) bsearch(&c_key, best_clusters, BEST_CLUSTERS, sizeof(int), ord_ordering);

       if (value) // the doc is in a best matching cluster
       {
        // boylece her best match clusterdan at most best doc tane aliyoz final resulta
        if (temp_results[c_key].current < BEST_DOCS)
        {
            temp_results[c_key].current++;
            // tabii result globally sorted oluyor sonucta!!
            results[q_no][no_of_res_found].doc_index = accumulator[j].doc_index;
            results[q_no][no_of_res_found].sim_rank = accumulator[j].sim_rank;
            //fprintf(out, "c_key %d d_id %d\n", c_key,accumulator[j].doc_index);
            no_of_res_found++;

            // ONEMLI
            // burada exit yapabiliriz for'dan, overlap de dok 1 kez gecsin dersek
            // yoksa bu prec recall vb sisirebilir...evet!
            // Check this!!!
            break;


        }
       } // if

   //free(value);
   }// for
   j++;

  } //while


    for (i=0; i<BEST_DOCS/*no_of_res_found*/; i++)
      fprintf(out, "res %d is document %d (c:%d)with sim %lf\n", i, results[q_no][i].doc_index,ICM[results[q_no][i].doc_index].cluster_list[0], results[q_no][i].sim_rank);
    // print statistics
    fprintf(out, "While processing %d:", q_no);
    fprintf(out, "Total query terms (lists) processed: %d\n", q_size);
    fprintf(out, "Sum of lengths of corresponding inverted lists(with skip nodes): %d\n", total_list_length);
    fprintf(out, "Total no of list nodes processed/accessed: %d\n",total_node_access);

    sum_list_length += total_list_length;
    sum_node_access += total_node_access;

} //func

void initialize_results()
{
   int i,j;

   // I need this, because ns * ds may not fill always
   // then the end of array may be empty, i.e. with 0s
   // aslinda actual result size yukarda count ile structure'a konabilirdi ama
   // ugrasmadim, may be dona as an optimization
   for (i= 0; i<QUERY_NO; i++)
       for (j=0; j<BEST_CLUSTERS * BEST_DOCS; j++)
       {
         results[i][j].doc_index = 0;
         results[i][j].sim_rank = -1;
       }

}


void process_ranked_query(char * rel_name)
{
  char line[MAX_TUPLE_LENGTH];
  long int tmp;
  int  i,j,k,p;
  char temp_line[MAX_TUPLE_LENGTH];
  char content[MAX_TUPLE_LENGTH];

///////
  //ptimer process_time;


  int max_tf;
  DocVec q_vec[QSIZE];

  long int token_freq, next;
  int count;

  //keep the header tag for a line
  char header[30];

  char open_tag[30], close_tag[30];

  char doc_id[20];


   //open input file
  if (!(ifp = fopen(rel_name, "rt")))
  {
      printf("file not found!\n");
      return;
  }

  tmp=0;


  // Now, I consider my data file as I only have R,
  // and run the code fragments written for only R
  processing_R = 1;

  //fgets(line, MAX_TUPLE_LENGTH, ifp); // read <xml version...>
  //fgets(line, MAX_TUPLE_LENGTH, ifp); // read doctype...

  // I changed file format  start with two blank lines

  fgets(line, MAX_TUPLE_LENGTH, ifp); // read blank line
  line[strlen(line)-1]=NULL;

  extract_header(header, line); // should be NULL

  // NOTE: considering school i don't use stricmp!


  while (!feof(ifp))
  {
     fgets(line, MAX_TUPLE_LENGTH, ifp); // read second blank line

     fgets(line, MAX_TUPLE_LENGTH, ifp); // read <top> line
     line[strlen(line)-1]=NULL;
     extract_header(header, line); // should be <top>


     if (strcmp(header,"<top>") == 0)
     {
       printf("ok, I see a new query starts!\n");
       tmp++;
     }
     else
      {
      printf("file structure mismatch error!!!");
      //fprintf(err_out,"ERROR file structure mismatch error!!!");
      exit(1);
      }

      //exit(1);

     fgets(line, MAX_TUPLE_LENGTH, ifp); // read a blank line

     fgets(line, MAX_TUPLE_LENGTH, ifp); // expect to read query number
     line[strlen(line)-1]=NULL;
     extract_header(header, line);


     if (strcmp(header, "<num>")==0)
        {
         extract_content(line, content);
         strcpy(doc_id, content);
         printf("aha %s\n", doc_id);
         }
     else
         {
         printf("Could not read document id?\n");
         //fprintf(err_out, "ERROR Could not read document id?\n");
         exit(1);
         }

     fgets(line, MAX_TUPLE_LENGTH, ifp); // read <title>
     line[strlen(line)-1]=NULL;
     extract_header(header, line);

            // do smt with ifs...
            if (strcmp(header, "<title>")==0)
            {

            extract_content(line, content);
            //process content
            if (USE_TITLE)
            {
            process_tuple(content, doc_no);
            printf("al title%s\n", content);
            }


             fgets(line, MAX_TUPLE_LENGTH, ifp);// read first headline line
             line[strlen(line)-1]=NULL;
             extract_header(header, line);

             while(strcmp(header, "<desc>")!=0)
             {

              extract_content(line, content);
              //process second line of title if exists
              if (USE_TITLE)
              {
              process_tuple(content, doc_no);
              printf("al title %s\n", content);
              }
              fgets(line, MAX_TUPLE_LENGTH, ifp);// read
              line[strlen(line)-1]=NULL;
              extract_header(header, line);

             } // end_while


            } // if for title

            if (strcmp(header, "<desc>")==0)
            {

             fgets(line, MAX_TUPLE_LENGTH, ifp);// read first headline line
             line[strlen(line)-1]=NULL;
             extract_header(header, line);


             while(strcmp(header, "<narr>")!=0)
             {

               extract_content(line, content);
               // process a description line
               if (USE_DESC)
               {
               process_tuple(content, doc_no);
               printf("desc; %s\n", content);
               }

              fgets(line, MAX_TUPLE_LENGTH, ifp);// read
              line[strlen(line)-1]=NULL;
              extract_header(header, line);

              } // end_while

            } //if for desc

           if (strcmp(header, "<narr>")==0)
            {

             fgets(line, MAX_TUPLE_LENGTH, ifp);// read first line
             line[strlen(line)-1]=NULL;
             extract_header(header, line);


             while(strcmp(header, "</top>")!=0)
             {

               extract_content(line, content);
               // process a description line
               if (USE_NARR)
               {
               process_tuple(content, doc_no);
               printf("narr; %s\n", content);
               }

              fgets(line, MAX_TUPLE_LENGTH, ifp);// read
              line[strlen(line)-1]=NULL;
              extract_header(header, line);

              } // end_while

            } //if for narrative


            // finished processing a query
            // do smt here with the query
            qsort(DVector,d_size,sizeof(DVector[0]),index_order);

            count = 0;
            token_freq=1;   // the freq. of a given token is set to 1 initially
            max_tf = -1;

            for (i=0; i<d_size; i++)
            {

               next = i+1;

               // I rely on short cut evaluation for the first expresion of if clause!
               if ( next<d_size && DVector[i].index==DVector[next].index)
                  token_freq++;

               else //now I will set the weight entry for a seen token
               {

               // put doc into final array or find weight

               q_vec[count].index = DVector[i].index;
               q_vec[count].rank_in_doc = token_freq; //DVector[i].rank_in_doc;
               // weight for query terms is n * CFC
               //q_vec[count].term_weight = q_vec[count].rank_in_doc * WordList[q_vec[count].index].CFCweight;
               //q_vec[count].address = WordList[q_vec[count].index].disk_address;

               // process the query for tis term...


               // set this to 1 for the next token

               count++;
               token_freq = 1;
               }  //else_part

               if (token_freq>max_tf)
                  max_tf = token_freq; //for weighting purposes

             } //for_ends

     fprintf(out, "max_tf for q_vector %d is %d\n",doc_no, max_tf);
     // set query weights
     for (i=0; i<count; i++)
     {
         // Indeed a term with rank 0 can not be in this vector...
         if (q_vec[i].rank_in_doc != 0)
                  q_vec[i].term_weight = (0.5 + 0.5 * (q_vec[i].rank_in_doc/max_tf)) * WordList[q_vec[i].index].CFCweight;
         else
                  q_vec[i].term_weight = 0;

         fprintf(out, "index %d tf %d CFC %lf q_weight %lf\n", q_vec[i].index, q_vec[i].rank_in_doc,WordList[q_vec[i].index].CFCweight, q_vec[i].term_weight);
         fflush(out);
     }


    u_cleartimer(process_time);
    u_starttimer(process_time);

    //time(&tstart);

     // run the query
     for (p=0; p<RUN_NO; p++)
     {
         run_ranking_query(q_vec, count, doc_no);
     }
    // time funcs
    //time(&tend);

    u_stoptimer(process_time);

//    u_addtimer(stime, process_time);

    t_sum += process_time->time;

    fprintf(out,"query:%d process time: %11.3lf\n",doc_no, process_time->time);
    printf("query:%d process time: %11.3lf\n",doc_no, process_time->time);

    //exit(1);

    //fprintf(out,"query:%d process time:%ld\n",doc_no, tend-tstart);

    //tsum += tend-tstart;

     // clear the used part of doc vector
     initialize_doc_vec(d_size); // so I avoid fully initializing the doc vec each time
     d_size = 0;
     doc_no++;
     //current_doc_id = doc_no;


     fgets(line, MAX_TUPLE_LENGTH, ifp);// read either EOF or blank
     //exit(1);


  }// end_while

  fclose (ifp);

  printf("Doc no: %ld %ld\n", doc_no, tmp);

}


void evaluate_ranked_query(char * rel_name)
{
  char line[MAX_TUPLE_LENGTH];
  long int tmp;
  int  i,j,k;
  int *value;
  int key;
  char temp_line[MAX_TUPLE_LENGTH];
  char content[MAX_TUPLE_LENGTH];
  int t1, t2, doc_number;
  double precision =0;
  double recall=0;
  double current_recall = 0;

  double prec_sum = 0;
  double current_prec = 0;

  int max_tf;
  int q_id, all_rel;
  int top_res;

  int ret_and_rel =0;
  double avg_prec= 0;

  DocVec q_vec[QSIZE];

  long int token_freq, next;
  int count;

  //keep the header tag for a line
  char header[30];

  char open_tag[30], close_tag[30];

  char doc_id[20];

  char f_name[15];

  char *m;

  //strcpy(f_name, "Qres");
  m = malloc(sizeof(char)*10);

  // initialize the PR values
  init_PR();
  init_Interpolated_PR();

   //open input file
  if (!(j_ifp = fopen(rel_name, "rt")))
  {
      printf("file not found!\n");
      return;
  }




  for (i=0; i<QUERY_NO; i++)
  {
      strcpy(f_name, "Qres");
      sprintf(m,"%d",i);
       strcat(f_name,m);
      strcat(f_name,".txt");

      record_out = fopen(f_name, "wt");
      //fprintf(record_out, "aha %s", f_name);

      //record_out = fopen("cBRN-log.txt", "wt");

      ret_and_rel = 0;
      fscanf(j_ifp, "%d %d\n", &q_id, &all_rel);
      for (j=0; j<all_rel; j++)
      {
         fscanf(j_ifp, "%d %s %d %d\n", &t1, &temp_line, &t2,&(relevants[j]));
         //printf("%d %s %d %d\n", t1, temp_line, t2,relevants[j]);
      }

      // I do this as i could not search 2-dim array
      /*
      for (j=0; j<TOP_N; j++)
      {
         temporary[j].index = results[i][j].doc_index;
         temporary[j].sim_rank = results][i][j].sim_rank;
      }
      */

      // in relevants, check for result, if found increase
      // modified value for TOPN, see the top
      for (j=0; j<TOP_N; j++)
      {
         //strcpy(sword->a_word,tokens[i]);
         //printf("%s ariyorum...\n", sword->a_word);
         //key = malloc(sizeof(int));
         value = malloc(sizeof(int));

         key = results[i][j].doc_index;
         /*
         if (key==348 && relevants[0]==348)
         {   printf("AHAAAAAAAAA %d \n", all_rel);
             //exit(1);
         }
         */
         value = (int *) bsearch(&key, relevants, all_rel, sizeof(int), ord_ordering);

         if (value)
         {
            ret_and_rel ++;

        current_prec += (double) ret_and_rel / (j+1);

        // recall at that moment, we will use these for plotting...
        if (all_rel != 0)
            current_recall = ((double) ret_and_rel) / all_rel;
        else
            current_recall = 0;

        fprintf(record_out, "rank %d prec %lf recal %lf\n", j, (double) ret_and_rel / (j+1), current_recall);
        PR_values[i].prec[j] = (double) ret_and_rel / (j+1);
        PR_values[i].recall[j] = current_recall;
        fprintf(record_out, "rank %d prec %lf recal %lf\n", j,PR_values[i].prec[j] ,PR_values[i].recall[j] );
            //fprintf(eval_out, "%d ",*value);
            //exit(1);
         }

         else
         {
            if (all_rel != 0)
               current_recall = ((double) ret_and_rel) / all_rel;
            else
                current_recall = 0;

            fprintf(record_out, "rank %d prec %lf recal %lf\n", j, (double) ret_and_rel / (j+1), current_recall);
            PR_values[i].prec[j] = (double) ret_and_rel / (j+1);
            PR_values[i].recall[j] = current_recall;
            fprintf(record_out, "rank %d prec %lf recal %lf\n", j,PR_values[i].prec[j] ,PR_values[i].recall[j] );
         } //else
         //exit(1);
      } //end for

  //fprintf(eval_out, "\n");

  top_res = TOP_N;
  precision = ((double) ret_and_rel)/ top_res;


  if (all_rel != 0)
    recall = ((double) ret_and_rel) / all_rel;
  else
    recall = 0;
  fprintf(eval_out, "q_no %d precision %lf recall %lf\n",i, precision, recall);

  if (ret_and_rel)
    avg_prec = current_prec/ret_and_rel;

  prec_sum += avg_prec;

  fprintf(eval_out, "q_no %d contributing the avg prec of %lf\n",i, avg_prec);

  fclose(record_out);

  avg_prec = 0;

  current_prec = 0;


  } // outer loop

  // call the interplation function
  interpolate_PR();

  print_Interpolated_PR();

  fprintf(eval_out, "mean avg precision is %lf\n", prec_sum/QUERY_NO);

}// func


void initialize_tempICList(int size)
{
   int i;

   for (i=0; i<size; i++)
   {
      tempICList[i].doc_id = 0;
      tempICList[i].weight = 0;
   }
}


// read IC file and process
void create_IC(char * rel_name)
{
  //long int tmp;
  int  i,j,k;
  int list_size; // the size of list that is read!

  InvEntry toWrite[16]; // now entires are centroid id and weight

  int current_word_no, read_word_no;

  //current_word_no = 1; // can not say this here, perhaps word 1 is in no centroids

  if (!(ICfile = fopen(rel_name,"rt")))
  {
      printf("file not found!\n");
      exit(1);
  }

  list_size = 0;

  // so, different from indexer5.c

  fscanf (ICfile, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",&read_word_no,
              &toWrite[1].doc_id,&toWrite[2].doc_id,&toWrite[3].doc_id,&toWrite[4].doc_id,&toWrite[5].doc_id,
              &toWrite[6].doc_id,&toWrite[7].doc_id,&toWrite[8].doc_id,&toWrite[9].doc_id,&toWrite[10].doc_id,
              &toWrite[11].doc_id,&toWrite[12].doc_id,&toWrite[13].doc_id,&toWrite[14].doc_id,&toWrite[15].doc_id);

  /*fprintf(out, "indices %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",read_word_no,
              toWrite[1].doc_id,toWrite[2].doc_id,toWrite[3].doc_id,toWrite[4].doc_id,toWrite[5].doc_id,
              toWrite[6].doc_id,toWrite[7].doc_id,toWrite[8].doc_id,toWrite[9].doc_id,toWrite[10].doc_id,
              toWrite[11].doc_id,toWrite[12].doc_id,toWrite[13].doc_id,toWrite[14].doc_id,toWrite[15].doc_id);
  */

  fscanf (ICfile, "%d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf\n",&read_word_no,
              &toWrite[1].weight,&toWrite[2].weight,&toWrite[3].weight,&toWrite[4].weight,&toWrite[5].weight,
              &toWrite[6].weight,&toWrite[7].weight,&toWrite[8].weight,&toWrite[9].weight,&toWrite[10].weight,
              &toWrite[11].weight,&toWrite[12].weight,&toWrite[13].weight,&toWrite[14].weight,&toWrite[15].weight);

  /*
  fprintf(out, "values %d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf\n",read_word_no,
              toWrite[1].weight,toWrite[2].weight,toWrite[3].weight,toWrite[4].weight,toWrite[5].weight,
              toWrite[6].weight,toWrite[7].weight,toWrite[8].weight,toWrite[9].weight,toWrite[10].weight,
              toWrite[11].weight,toWrite[12].weight,toWrite[13].weight,toWrite[14].weight,toWrite[15].weight);
  */

  // keep toWrite content somewhere
  // copy values to current docvec. I am doing this further possible processing
  i = 1;
  while (i<16 && toWrite[i].doc_id != 0)
  {
         // now add this centroid id to the current posting list
         tempICList[list_size].doc_id = toWrite[i].doc_id;
         tempICList[list_size].weight = toWrite[i].weight;

         list_size++;
         i++;
      }

  current_word_no = read_word_no;

  while (!feof(ICfile))
  {
      fscanf (ICfile, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",&read_word_no,
              &toWrite[1].doc_id,&toWrite[2].doc_id,&toWrite[3].doc_id,&toWrite[4].doc_id,&toWrite[5].doc_id,
              &toWrite[6].doc_id,&toWrite[7].doc_id,&toWrite[8].doc_id,&toWrite[9].doc_id,&toWrite[10].doc_id,
              &toWrite[11].doc_id,&toWrite[12].doc_id,&toWrite[13].doc_id,&toWrite[14].doc_id,&toWrite[15].doc_id);

  /*    fprintf(out,"indices %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",read_word_no,
              toWrite[1].doc_id,toWrite[2].doc_id,toWrite[3].doc_id,toWrite[4].doc_id,toWrite[5].doc_id,
              toWrite[6].doc_id,toWrite[7].doc_id,toWrite[8].doc_id,toWrite[9].doc_id,toWrite[10].doc_id,
              toWrite[11].doc_id,toWrite[12].doc_id,toWrite[13].doc_id,toWrite[14].doc_id,toWrite[15].doc_id);
  */
      fscanf (ICfile, "%d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf\n",&read_word_no,
              &toWrite[1].weight,&toWrite[2].weight,&toWrite[3].weight,&toWrite[4].weight,&toWrite[5].weight,
              &toWrite[6].weight,&toWrite[7].weight,&toWrite[8].weight,&toWrite[9].weight,&toWrite[10].weight,
              &toWrite[11].weight,&toWrite[12].weight,&toWrite[13].weight,&toWrite[14].weight,&toWrite[15].weight);

    /*
      fprintf(out, "values %d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf\n",read_word_no,
              toWrite[1].weight,toWrite[2].weight,toWrite[3].weight,toWrite[4].weight,toWrite[5].weight,
              toWrite[6].weight,toWrite[7].weight,toWrite[8].weight,toWrite[9].weight,toWrite[10].weight,
              toWrite[11].weight,toWrite[12].weight,toWrite[13].weight,toWrite[14].weight,toWrite[15].weight);
      */

       //printf("simdi %d\n", doc_id);
       if (read_word_no != current_word_no)
       {
            // I see a posting list for a new term, so finish job for the older one
            //printf ("Here is doc no %d and dszie %d :\n", current_doc_id,d_size);

            /*
            for (j=0; j<list_size; j++)
            {
               // compute tf*cfc value
               DVector[j].term_weight = ((double) DVector[j].rank_in_doc) * WordList[DVector[j].index].CFCweight;
            }

            // normalize d_vector
            dvec_normalize(d_size);
            */

            //fprintf(out, "word no: %d size:%d \n", current_word_no, list_size);
            // Note; we could use tempICList as pointer, so no need for copying
            // alocate space for the posting list and copy it to its final place
            WordList[current_word_no].cent_list_length = list_size;
            WordList[current_word_no].clusterList = (InvEntry *) malloc(sizeof(InvEntry) * list_size);
            for (j=0; j<list_size; j++)
            {
               //add_to_index(current_doc_id,DVector[j].index, DVector[j].term_weight, -1);
               WordList[current_word_no].clusterList[j].doc_id = tempICList[j].doc_id;
               WordList[current_word_no].clusterList[j].weight = tempICList[j].weight;
               //fprintf(out, "centroid_doc_id:%d, weight %lf\n",WordList[current_word_no].clusterList[j].doc_id,WordList[current_word_no].clusterList[j].weight);

            } // end_for




            initialize_tempICList(list_size);
            list_size = 0;
            current_word_no = read_word_no;
       }

        // copy values to current docvec. I am doing this further possible processing
         i = 1;
         while (i<16 && toWrite[i].doc_id != 0)
         {
             // now add this centroid id to the current posting list
             tempICList[list_size].doc_id = toWrite[i].doc_id;
             tempICList[list_size].weight = toWrite[i].weight;

            list_size++;
            i++;
         }

  }// end_while

  // process the last document
  //process, find the cluster etc...
  // I saw a new document, so I will process the older doc
  // and initialize variables for the new one
  //printf ("Here is doc no %d and dszie %d :\n", current_doc_id,d_size);
  /*
  for (j=0; j<list_size; j++)
  {
      // compute tf*cfc value
      DVector[j].term_weight = ((double) DVector[j].rank_in_doc) * WordList[DVector[j].index].CFCweight;
  }

  // normalize d_vector
  dvec_normalize(d_size);
  */

  // Note; we could use tempICList as pointer, so no need for copying
  // alocate space for the posting list and copy it to its final place
  WordList[current_word_no].cent_list_length = list_size;
  WordList[current_word_no].clusterList = (InvEntry *) malloc(sizeof(InvEntry) * list_size);
  //fprintf(out, "word no: %d\n", current_word_no);
  for (j=0; j<list_size; j++)
  {
      WordList[current_word_no].clusterList[j].doc_id = tempICList[j].doc_id;
      WordList[current_word_no].clusterList[j].weight = tempICList[j].weight;
      //fprintf(out, "centroid_doc_id:%d, weight %lf\n",WordList[current_word_no].clusterList[j].doc_id,WordList[current_word_no].clusterList[j].weight);
  }


  fclose (ICfile);

  // close otput files
  //fclose(out);
  //fclose(d_out);
}

int
random_int (int max) /* return a random integer in [0,max) */
{
  if (max == 0) return (0);
  return (random()%max);
} /* random_int */


rand_ICM()
{
 int i;

  //out = fopen("rand.txt", "wt");

 for (i=1; i<DOC_NUM; i++)
 {
   ICM[i].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[i].cluster_list = (int *) malloc(sizeof(int)*ICM[i].clusters_doc_in);
   ICM[i].cluster_list[0] = random_int(100); // give a random cluster no
   //fprintf(out,"doc %d cluster %d\n", i, ICM[i].cluster_list[0]);
   //fflush(out);
 }

 //fclose(out);

}

rand_ICM2()
{
   ICM[1].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[1].cluster_list = (int *) malloc(sizeof(int)*ICM[1].clusters_doc_in);
   ICM[1].cluster_list[0] = 1; // give a random cluster no

   ICM[2].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[2].cluster_list = (int *) malloc(sizeof(int)*ICM[2].clusters_doc_in);
   ICM[2].cluster_list[0] = 2; // give a random cluster no

   ICM[3].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[3].cluster_list = (int *) malloc(sizeof(int)*ICM[3].clusters_doc_in);
   ICM[3].cluster_list[0] = 3; // give a random cluster no

   ICM[4].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[4].cluster_list = (int *) malloc(sizeof(int)*ICM[4].clusters_doc_in);
   ICM[4].cluster_list[0] = 4; // give a random cluster no

   ICM[5].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[5].cluster_list = (int *) malloc(sizeof(int)*ICM[5].clusters_doc_in);
   ICM[5].cluster_list[0] = 2; // give a random cluster no

   ICM[6].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[6].cluster_list = (int *) malloc(sizeof(int)*ICM[6].clusters_doc_in);
   ICM[6].cluster_list[0] = 3; // give a random cluster no

   ICM[7].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[7].cluster_list = (int *) malloc(sizeof(int)*ICM[7].clusters_doc_in);
   ICM[7].cluster_list[0] = 1; // give a random cluster no

   ICM[8].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[8].cluster_list = (int *) malloc(sizeof(int)*ICM[8].clusters_doc_in);
   ICM[8].cluster_list[0] = 1; // give a random cluster no

   ICM[9].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[9].cluster_list = (int *) malloc(sizeof(int)*ICM[9].clusters_doc_in);
   ICM[9].cluster_list[0] = 2; // give a random cluster no

   ICM[10].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[10].cluster_list = (int *) malloc(sizeof(int)*ICM[10].clusters_doc_in);
   ICM[10].cluster_list[0] = 3; // give a random cluster no

}

void process_ICM(char * relname)
{
   int i, j;
   int doc_id;
   int no_of_clus; // the number of clusters that doc is in

   //open file
   if (!(ICMfile = fopen(relname,"rt")))
   {
      printf("file not found!\n");
      exit(1);
   }

   // Again, remember docs start from 1
   for (i=1; i<DOC_NUM; i++)
   {
      fscanf(ICMfile, "%d %d", &doc_id, &no_of_clus);
      if (i!= doc_id)
      {
         printf("something is wrong!!\n");
         exit(1);
      }


      ICM[i].clusters_doc_in = no_of_clus;
      //fprintf(out, "Doc %d is in %d clusters: ", i,ICM[i].clusters_doc_in);

      ICM[i].cluster_list = (int *) malloc(sizeof(int)*ICM[i].clusters_doc_in);
      for (j=0; j<no_of_clus; j++)
      {
         fscanf(ICMfile, " %d", &(ICM[i].cluster_list[j]));
         //fprintf(out, "%d ",ICM[i].cluster_list[j]);
      }
      //fprintf(out, "\n");
   } // outer loop

   fclose (ICMfile);
}


main() //(int argc,char *argv[])
{
  int i,j,k, t;
  char file_name[15], file_name2[15];
  char *f,*r, *m, pre, end;
  int FileNumber[13];
  int file_index;
  char line[MAX_TUPLE_LENGTH];
  char str[TOKEN_SIZE];
  int rank;
  int actual_cent_no, last_seen ;
  int temp;
  double tempo;

  long int address;

  /*
  if (argc!= 2)
  {
    printf("Usage: <exe_name> <window_size>\n");
    exit(0);
  } */


    //u_cleartimer(process_time);

  // read structure and construct the model
  // we will use this to find total no of documents considered
  create_C3M_Cluster("info.txt");

  // ***I do this here as I will process multi-file
  out = fopen("cbr2-log.txt", "wt");
  //d_out = fopen("dvec.txt","wt");

  //d_out = fopen("qvec.txt","wt");


  printf("CBR skipped system v1.0\n");

  //err_out = fopen("indexer-logs.txt", "wt");

  ifp = fopen("stopword.lst","rt") ;

  for (i=0;i<NOSTOPWORD;i++)
    fscanf(ifp,"%s\n",stopwords[i]) ;


  fclose(ifp) ;


   // initialize WordList
   // well I do not need to do that, as I handle it while reading
   // In this version, I keep only the necessary structures for each word:
   // namely; a_Word, occurrs_in_docs, CFCweight and disk_address

   // read stopwords here!!!

  //open file // modified for new words
  if (!(ifp = fopen("newwords.txt","rt")))
  {
      printf("file not found!\n");
      exit(1);
  }

  // DIKKAT: index 1 den basliyor effectively
  word_no_in_list=1;

  while (!feof(ifp))
  {
      // wordlist format <string blank occurrence_no blank CFCweight eol>

      fscanf (ifp, "%s %d %lf\n", str, &(WordList[word_no_in_list].occurs_in_docs), &(WordList[word_no_in_list].CFCweight)); //&rank);
      strcpy(WordList[word_no_in_list].a_word, str);


      term_generality += WordList[word_no_in_list].occurs_in_docs;

      if (WordList[word_no_in_list].occurs_in_docs > max_freq_term)
          max_freq_term =
          WordList[word_no_in_list].occurs_in_docs;

      if (WordList[word_no_in_list].occurs_in_docs < min_freq_term)
          min_freq_term = WordList[word_no_in_list].occurs_in_docs;

      if (word_no_in_list>1)
         WordList[word_no_in_list].disk_address =WordList[word_no_in_list-1].disk_address+(sizeof(InvEntry)*WordList[word_no_in_list-1].occurs_in_docs);
      else
         WordList[word_no_in_list].disk_address = 0;

      // jan 15

      WordList[word_no_in_list].IC_disk_address = -1;
      WordList[word_no_in_list].cent_list_length = -1;
      WordList[word_no_in_list].clusterList = NULL;
      word_no_in_list++;

  }

  fclose(ifp);

  // here word_no_in_list-1 as I start from 1
  printf("i initialized the word list with %d words, guys\n", word_no_in_list-1);


  // initialize cluster membership info
  // read from a file
  // okulda skip4 de var, buraya koyalim...
  //rand_ICM();
  //  rand_ICM2();
  process_ICM("ICM.txt");

  // read IC from a file
  // process IC entries
  /*
  initialize_tempICList(MAX_LIST_LENGTH);
  create_IC("IC_db.txt");
  */



  if (!(ifp = fopen("c-words.txt","rt")))
  {
      printf("file not found!\n");
      exit(1);
  }

  actual_cent_no = 1;
  last_seen =-1;

  while (!feof(ifp))
  {
      // wordlist format <string blank occurrence_no blank CFCweight eol>

      fscanf (ifp, "%s %d %lf\n", str, &temp, &tempo); //&rank);

     //fprintf(out, "temp %d\n", temp);
      if (temp>-1)
      {

      if (last_seen == -1)
        last_seen = 0;


      WordList[actual_cent_no].cent_list_length = temp;

      if (last_seen>0)
         WordList[actual_cent_no].IC_disk_address = WordList[last_seen].IC_disk_address+(sizeof(InvEntry)*WordList[last_seen].cent_list_length);
      else
         WordList[actual_cent_no].IC_disk_address = 0;

      last_seen = actual_cent_no;
      }

      actual_cent_no++;

  }

  fclose(ifp);



  printf("now I finished creating IC (inverted centroid) index\n");

  //fclose(out);
  //exit(1);

  // initialize doc_vector
  // Currently, I am keeping this as an extra structure
  initialize_doc_vec(DOC_SIZE);

  // initialize both temp results and final results
  // final results should be initialized, as there may be less docs than ns*ds
  initialize_results();
  initialize_temp_results();

  //open file    // modified for skipped index
  if (!(entry_ifp = fopen("skipped.txt","rb")))
  {
      printf("file not found!\n");
      exit(1);
  }

  if (!(entry_ic = fopen("ic_db.bin","rb")))
  {
      printf("file not found!\n");
      exit(1);
  }

 // for debug
 /*
  for (i=1; i<word_no_in_list; i++)
  {
     if (WordList[i].cent_list_length >-1)
     {
     fprintf(out,"word %s ic address %ld list length  %d\n", WordList[i].a_word, WordList[i].IC_disk_address, WordList[i].cent_list_length);


        address = WordList[i].IC_disk_address;
        fseek(entry_ic,address, 0);
        fread(cent_buffer, sizeof(InvEntry), WordList[i].cent_list_length, entry_ic);

        for (j=0; j<WordList[i].cent_list_length; j++)
           fprintf(out, "LOOK doc id %d weight_in_doc %lf\n",cent_buffer[j].doc_id,cent_buffer[j].weight);
    }


    }

  fclose(out);
    */



  //fclose(out);

  //time start
  // I process all queries at once and return results
  // If desired otherwise, one can put each query in one file and process in a loop
  process_ranked_query("q-topics.txt");
  //end time

  //fprintf(out,"total query time: %ld\n", tsum);
  //printf("total query time: %ld\n", tsum);
//  u_printtimer(stime,"Total query time:");
  fprintf(out,"Total query process time: %11.3lf\n", t_sum);

  fclose(entry_ifp);
  fclose(out);

  printf("now start evaluation\n");
  printf("Sum of lengths of corresponding inverted lists(with skip nodes): %d\n", total_list_length);
  printf("Total no of list nodes processed/accessed: %d\n",total_node_access);


  eval_out = fopen("CBR2_ranked.txt", "wt");

  fprintf(eval_out,"no of results returned: top %d\n", BEST_DOCS);
  fprintf(eval_out,"no of clusters selected: best %d\n", BEST_CLUSTERS);

  // for each query handles, evaluate judgements
  evaluate_ranked_query("judgeso.txt");

  fprintf(eval_out, "avg query length (over all queries): %lf\n",total_qlength/(double) QUERY_NO);
  fprintf(eval_out, "min query length (over all queries): %d\n",min_qlength);
  fprintf(eval_out, "max query length (over all queries): %d\n",max_qlength);

  fprintf(eval_out, "avg total list length (over all queries): %lf\n",sum_list_length/(double) QUERY_NO);
  fprintf(eval_out, "avg total node access (over all queries): %lf\n",sum_node_access/(double) QUERY_NO);

  fprintf(eval_out, "avg no of docs considered (over all queries): %lf \n", grand_total_docs/(double)QUERY_NO);
  fprintf(eval_out, "min no of docs considered (over all queries): %d \n", min_total);
  fprintf(eval_out, "max no of docs considered (over all queries): %d \n", max_total);
  fprintf(eval_out, "Total query process time: %11.3lf\n", t_sum);

  fprintf(eval_out, "term_generality: %lf\n",term_generality/(word_no_in_list-1));
  fprintf(eval_out, "max freq term %d\n", max_freq_term);
  fprintf(eval_out, "min freq term %d\n", min_freq_term);

  fclose(eval_out);

  // process_ANDquery("q-file.txt");

  printf("finished processing\n");

  fclose(entry_ifp);
//  fclose(out);


}
